#include <iostream>

class ListContent
{
public :
    int value;
    ListContent* next;
};

class Stack {
private:
    ListContent begin, end;

public :
    Stack() {
        begin.next = &end;
    }
    ~Stack() {
        ListContent* iterator = begin.next;
        while(iterator != &end) {
            ListContent* temp = iterator->next;
            delete temp;
        }
    }

    bool isEmpty() {
        return (begin.next == &end);
    }
    void push(int val) {
        // Vvf̍쐬
        ListContent* new_val = new ListContent;
        new_val->value = val;

        // vf̑}
        new_val->next = begin.next;
        begin.next = new_val;
    }
    void pop() {
        ListContent* del = begin.next;
        begin.next = del->next;

        delete del;
    }
    int top() {
        return begin.next->value;
    }
};

int main()
{
    Stack s;
    
    int input_num;
    while(true) {
        std::cout << "l̓(0 ŏI) : ";
        std::cin >> input_num;
        
        if(input_num == 0) break;
        s.push(input_num);
    }

    while( ! s.isEmpty() )
    {
        std::cout <<  s.top() << " " << std::endl;
        s.pop();
    }
    
    return 0;
}
