#include <iostream>


class Vector {
private :
    int d_arr_num;
    int* d_arr;

public :
    Vector() : d_arr_num(0), d_arr(0) {}
    Vector(int n) : d_arr_num(n), d_arr(new int[n]) {}
    ~Vector() {delete[] d_arr;}

    void resize(int size) {
        //Vz̐
        int* temp = d_arr;
        d_arr = new int[size];

        // l̃Rs[(vf͂ݏoȂ悤ɒ)
        int limit = size > d_arr_num ? d_arr_num : size;
        for(int i = 0; i < limit; ++i)
        {
            d_arr[i] = temp[i];
        }
        d_arr_num = size;

        // Âz̍폜
        delete[] temp;
    }

    void set(int index, int val)
    {
        if(d_arr_num <= index) 
        {
            resize(index + 1);
        }
        d_arr[index] = val;
    }

    int get(int index)
    {
        if(d_arr_num < index)
        {
            return -1;
        }
        return d_arr[index];
    }

    int getSize()
    {
        return d_arr_num;
    }

    int* getPointer()
    {
        return d_arr;
    }
};



int main()
{
    Vector v;
    
    int input_num, index;
    while(true) {
        std::cout << "l̓(index value) (0 0) ŏI : ";
        std::cin >> index >> input_num;
        
        if(input_num == 0 && index == 0) break;
        v.set(index, input_num);
    }

    int max = v.getSize();
    for(int i = 0; i < max; ++i)
    {
        std::cout << v.get(i) << " ";
    }
    std::cout << std::endl;

    return 0;
}
